using System;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Linq;
using System.Collections.Generic;
using System.Data;
using System.Configuration;
using System.Data.SqlClient;
public partial class _Default : System.Web.UI.Page
{
    protected void Page_PreInit(object sender, EventArgs e)
    {
        if (this.IsPostBack)
        {
            List<string> keys = Request.Form.AllKeys.Where(key => key.Contains("ddlDynamic")).ToList();
            int i = 1;
            foreach (string key in keys)
            {
                this.CreateDropDownList("ddlDynamic" + i);
                i++;
            }
        }
    }

    protected void AddDropDownList(object sender, EventArgs e)
    {
        int index = pnlDropDownLists.Controls.OfType<DropDownList>().ToList().Count + 1;
        this.CreateDropDownList("ddlDynamic" + index);
    }

    private void CreateDropDownList(string id)
    {
        DropDownList dropDown = new DropDownList();
        dropDown.ID = id;

        string constr = ConfigurationManager.ConnectionStrings["constr"].ConnectionString;
        using (SqlConnection con = new SqlConnection(constr))
        {
            using (SqlCommand cmd = new SqlCommand("SELECT CustomerId, Name FROM Customers"))
            {
                cmd.Connection = con;
                con.Open();
                dropDown.DataSource = cmd.ExecuteReader();
                dropDown.DataTextField = "Name";
                dropDown.DataValueField = "CustomerId";
                dropDown.DataBind();
                con.Close();
            }
        }

        pnlDropDownLists.Controls.Add(dropDown);

        Literal lt = new Literal();
        lt.Text = "<br />";
        pnlDropDownLists.Controls.Add(lt);
    }

    protected void Save(object sender, EventArgs e)
    {
        foreach (DropDownList dropDown in pnlDropDownLists.Controls.OfType<DropDownList>())
        {
            string constr = ConfigurationManager.ConnectionStrings["constr"].ConnectionString;
            using (SqlConnection con = new SqlConnection(constr))
            {
                using (SqlCommand cmd = new SqlCommand("INSERT INTO Names(Name) VALUES(@Name)"))
                {
                    cmd.Connection = con;
                    cmd.Parameters.AddWithValue("@Name", dropDown.SelectedItem.Text);
                    con.Open();
                    cmd.ExecuteNonQuery();
                    con.Close();
                }
            }
        }
    }
}
