Imports System.Data
Imports System.Configuration
Imports System.Data.SqlClient
Partial Class VB
    Inherits System.Web.UI.Page

    Protected Sub Page_PreInit(ByVal sender As Object, ByVal e As EventArgs) Handles Me.PreInit
        If Me.IsPostBack Then
            Dim keys As List(Of String) = Request.Form.AllKeys.Where(Function(key) key.Contains("ddlDynamic")).ToList()
            Dim i As Integer = 1
            For Each key As String In keys
                Me.CreateDropDownList("ddlDynamic" & i)
                i += 1
            Next
        End If
    End Sub

    Protected Sub AddDropDownList(ByVal sender As Object, ByVal e As EventArgs)
        Dim index As Integer = pnlDropDownLists.Controls.OfType(Of DropDownList)().ToList().Count + 1
        Me.CreateDropDownList("ddlDynamic" & index)
    End Sub

    Private Sub CreateDropDownList(ByVal id As String)
        Dim dropDown As DropDownList = New DropDownList()
        dropDown.ID = id
        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As SqlConnection = New SqlConnection(constr)
            Using cmd As SqlCommand = New SqlCommand("SELECT CustomerId, Name FROM Customers")
                cmd.Connection = con
                con.Open()
                dropDown.DataSource = cmd.ExecuteReader()
                dropDown.DataTextField = "Name"
                dropDown.DataValueField = "CustomerId"
                dropDown.DataBind()
                con.Close()
            End Using
        End Using

        pnlDropDownLists.Controls.Add(dropDown)
        Dim lt As Literal = New Literal()
        lt.Text = "<br />"
        pnlDropDownLists.Controls.Add(lt)
    End Sub

    Protected Sub Save(ByVal sender As Object, ByVal e As EventArgs)
        For Each dropDown As DropDownList In pnlDropDownLists.Controls.OfType(Of DropDownList)()
            Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
            Using con As SqlConnection = New SqlConnection(constr)
                Using cmd As SqlCommand = New SqlCommand("INSERT INTO Names(Name) VALUES(@Name)")
                    cmd.Connection = con
                    cmd.Parameters.AddWithValue("@Name", dropDown.SelectedItem.Text)
                    con.Open()
                    cmd.ExecuteNonQuery()
                    con.Close()
                End Using
            End Using
        Next
    End Sub
End Class
